// Effects
datablock ParticleData(wrenchExplosionParticle)
{
   dragCoefficient      = 5;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "fps/data/particles/snowflake";
   colors[0]     = "0.0 0.7 0.9 0.9";
   colors[1]     = "0.0 0.0 0.9 0.0";
   sizes[0]      = 0.7;
   sizes[1]      = 0.2;
};

datablock ParticleEmitterData(wrenchExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "wrenchExplosionParticle";
};

datablock ExplosionData(wrenchExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   particleEmitter = wrenchExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "2.0 2.0 2.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   soundProfile = wrenchHit;
};


//projectile
datablock ProjectileData(wrenchProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 10;
   radiusDamage        = 10;
   damageRadius        = 0.5;
   explosion           = wrenchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

};


//////////
// item //
//////////
datablock ItemData(wrench)
{
	category = "Tools";  // Mission editor category
	className = "Tool"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-Ons/Shapes/Wrench/wrench.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
        skinName = 'red';

	 // Dynamic properties defined by the scripts
	pickUpName = 'a wrench';
	invName = 'Wrench';
	image = wrenchImage;
};

//function wrench::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(wrenchImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/shapes/Wrench/wrench.dts";

   emap = true;
	cloakable = false;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = wrench;
   ammo = " ";
   projectile = wrenchProjectile;
   projectileType = Projectile;
	
   //melee particles shoot from eye node for consistancy
   melee = true;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                 = "onStopFire";
};

function wrenchImage::onPreFire(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'wrench prefired!!!');
	//Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, armattack);
}

function wrenchImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function removeFromMoverList(%obj)
{
	for(%t = 0; %t < $TotalMoversPlaced + 1; %t++)
	{
		if(%obj == $Movers[%t])
		{
			$Movers[%t] = 0;
		}
	} 
}

function wrenchProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	if (%col.getClassName() !$= "StaticShape" && %col.getClassName() !$= "Player")
		return;

	%colData = %col.getDataBlock();
	%colDataClass = %colData.classname;
	ServerPlay3D(wrenchMiss);

	if(%obj.client.grouped == 1)
	{
		//
	}
	else if(%obj.client.grouped == 0)
	{
		%isTrusted = 0;
		for(%i = 0; %i <= $Trust::numTrusts; %i++)
		{
			if(%col.owner $= $Trust::ip[%i])
			{
				%isTrusted = 1;
			}
		}
		
		%isGroupBrick = 0;
		for(%i = 0; %i <= $Group::numGroup; %i++)
		{
			if(%col.owner $= $Group::ip[%i])
			{
				%isGroupBrick = 1;
			}
		}
		
		if(%colDataClass $= "brick")
		{
				
			if(((%col.owner $= getRawIP(%obj.client)) || (%isTrusted == 0)) && (%isGroupBrick == 0))
			{		
				if(%isTrusted == 1)
				{
					%obj.client.WrenchObject = %col;
					ServerPlay3D(wrenchHit);
					commandtoclient(%client,'OpenWrenchMenuGui');
				}
				else
				{
					clientcmdcenterprint("You do not have enough trust to do that.", 1);
					ServerPlay3D(wrenchMiss);
				}
			}
		}
	}
}

function serverCmdsetBricktoNorm(%client)
{
	%col = %client.WrenchObject;

	%col.isDoor = "";
	%col.MoveXYZ = "";
	%col.Steps = "";
	%col.StepTime = "";
	%col.RotateXYZ = "";
	%col.ReturnDelay = "";
	%col.ReturnToggle = "";
	%col.Elevator = "";
	%col.Private = "";
	%col.noCollision = "";
	%col.isMoving = "";
	%col.TriggerDoorID = "";
	%col.HasReturned = "";
	%col.Password = "";
	%col.Team = "";
	%col.Group = "";
	%col.DoorType = "";
	%col.TriggerCloak = "";
	%col.Elevator = "";
	%col.isImpulseTrigger = "";
	messageClient(%client,"","\c4You Removed the Brick Properties!");
}

function setBricktoMover(%client)
{
	%col = %client.WrenchObject;
								
	if(%client.TotalMovers < $Pref::Server::MaxDoors)
	{
		if(%col.isDoor != 1)
		{
			servercmdsetBricktoNorm(%client);
			messageClient(%client,"","\c4Gave Brick Movement Properties");
		}
		else
		{	
			servercmdsetBricktoNorm(%client);
			messageClient(%client,"","\c4You Replaced the Brick Properties!");
		}

		if(!%client.isAdmin || !%client.isSuperAdmin)
		{
			%XYZ = %client.WrenchMoveXYZ;
			%X = getWord(%XYZ, 0);
			%Y = getWord(%XYZ, 1);
			%Z = getWord(%XYZ, 2);
			%client.stepTime = mFloor(%client.stepTime);
			if(%client.StepTime >= 1000 || %client.StepTime < 0)
			{
				messageClient(%client,"","\c4You cannot have more than 1000 Steps, or less than 0.");
				return;				
			}
			if(%client.WrenchSteps >= 1000 || %client.WrenchSteps < 0)
			{
				messageClient(%client,"","\c4You cannot have more than 1000 Steps, or less than 0.");
				return;				
			}
			
			if(%X >= 500 || %Y >= 500 || %Z >= 500 || %X <= -500 || %Y <= -500 || %Z <= -500)
			{
				messageClient(%client,"","\c4You cannot have any Move Value as more than 500.");
				return;
			}
		}

		%col.isDoor = 1;
		%col.MoveXYZ = %client.WrenchMoveXYZ;
		%col.RotateXYZ = %client.WrenchRotateXYZ;
		%col.Steps = %client.WrenchSteps;
		%col.StepTime = %client.WrenchStepTime;
		%col.ReturnDelay = %client.WrenchReturnDelay;
		%col.Elevator = %client.WrenchElevator;
		%col.noCollision = %client.WrenchNoCollision;
		%col.HasReturned = 1;

		if(%client.WrenchDoorType $= "Trigger")
		{
			%col.DoorType = 1;
			%col.TriggerDoorID = %client.WrenchDoorSetID;
		}
		else if(%client.WrenchDoorType $= "Triggered")
		{
			%col.DoorType = 2;
			%col.TriggerDoorID = %client.WrenchDoorSetID;
		}
		else if(%client.WrenchDoorType $= "Normal")
		{
			%col.DoorType = 3;
		}
	
		if(%client.WrenchReturnToggle $= 1)
		{
			%col.ReturnToggle = 1;
		}
		else
		{
			%col.ReturnToggle = 0;
		}

		if(%client.WrenchImpTrigger $= 1)
		{
			%col.TriggerDoorID = %client.WrenchDoorSetID;
			%col.isImpulseTrigger = 1;
		}
		
		if(%client.WrenchTriggerCloak)
		{
			%col.TriggerCloak = %client.WrenchTriggerCloak;
		}
		
		if(%client.WrenchPrivate !$= "")
		{
			%col.Private = %client.WrenchPrivate;
		}
		
		if(%client.WrenchPassword !$= "")
		{
			%col.Password = %client.WrenchPassword;
		}

		if(%client.WrenchTeam !$= "")
		{
			%col.Team = %client.WrenchTeam;
		}

		if(%client.WrenchGroup !$= "")
		{
			%col.Group = %client.WrenchGroup;
		}
	 
		$Movers[$TotalMoversPlaced++] = %col;
		%client.TotalMovers++;
		commandtoclient(%client,'CloseWrenchMenu');
	}
	else
	{
		if($Pref::Server::MaxDoors $= 0)
		{
			commandtoclient(%client,'CloseWrenchMenu');
			messageClient(%client,"","\c4Movers are not allowed on this server!");
		}
		else
		{
			commandtoclient(%client,'CloseWrenchMenu');
			messageClient(%client,"",'\c4There is a limit of \c0%1',$Pref::Server::MaxDoors);
		}
	}
}


function serverCmdapplyImpulse(%client, %X, %Y, %Z, %Trigger, %TriggerID)
{
	%col = %client.WrenchObject;
	%col.isImp = 1;
	if(%Trigger $= 1)
	{
	%col.isTriggerImp = 1;
	%col.TriggerDoorID = %TriggerID;
	}
	%col.Imp = %X * 100 SPC %Y * 100 SPC %Z * 100;
	//messageClient(%client,"","\c4You have given the Brick Impulse Properties.");
}


function serverCmdgetWrenchSettings(%client)
{
	%col = %client.WrenchObject;

	if(%col.isDoor $= 1)
	   %yesno = 1;
	else
	   %yesno = 0;

	messageClient(%client,'MsgUpdateWrenchA',"",%col.MoveXYZ,%col.RotateXYZ,%col.Steps,%col.StepTime,%col.Elevator,%col.TriggerCloak,%col.Private,%col.Team,%col.Group,%yesno);
	messageClient(%client,'MsgUpdateWrenchB',"",%col.isImpulseTrigger,%col.returnDelay,%col.returnToggle,%col.password,%col.DoorType,%col.TriggerDoorID,%col.NoCollision,%yesno);
}

function serverCmdgetImpulseSettings(%client)
{
	%col = %client.WrenchObject;
	messageClient(%client,'MsgUpdateWrenchI',"",%col);
}