//flame.cs
//Flamethrower that does area damage. Made by Amade (Blockland.us).


//sound
datablock AudioProfile(flameFireSound)
{
   filename    = "~/data/sound/sprayLoop.wav";
   description = AudioClosestLooping3d;
   preload = true;
};

datablock AudioProfile(flameExplosionSound)
{
   filename    = "~/data/sound/flamethrowerloop.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(flameActivateSound)
{
   filename    = "~/data/sound/flamethrowerloop.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock ParticleData(flameTrailParticle)
{
	dragCoefficient      = 2.5;
	gravityCoefficient   = -0.17;
	inheritedVelFactor   = 1;
	constantAcceleration = 0;
	lifetimeMS           = 1250;
	lifetimeVarianceMS   = 750;
	textureName          = "~/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]	= "0.1 0.1 1 1";
	colors[1]	= "1 0.5 0 0.5";
	colors[2]	= "1 0.25 0 0.25";
	colors[3]	= "1 0 0 0";
	sizes[0]	= 0.25;
	sizes[1]	= 0.5;
	sizes[2]	= 0.55;
	sizes[3]	= 0.7;
	times[0]	= 0;
	times[1]	= 0.2;
	times[2]	= 0.8;
	times[3]	= 1;

	useInvAlpha = false;
};

datablock ParticleEmitterData(flameTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 1;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0.25;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = flameTrailParticle;
};

datablock ParticleData(flameAmbientParticle)
{
	dragCoefficient      = 1.5;
	gravityCoefficient   = -0.25;
	inheritedVelFactor   = 0.5;
	windCoefficient      = 0.1;
	constantAcceleration = 0;
	lifetimeMS           = 400;
	lifetimeVarianceMS   = 100;
	textureName          = "~/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.65 0 0.5";
	colors[1]     = "1 0 0 0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.05;

	useInvAlpha = false;
};
datablock ParticleEmitterData(flameAmbientEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.5;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flameAmbientParticle";

   uiName = "Flame Ambient";
};

datablock ParticleEmitterData(flameFireEmitter)
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.5;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flameTrailParticle";

   uiName = "Flame";
};

datablock ParticleData(flameExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.2;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 500;
	textureName          = "~/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0 0 0.6";
	colors[1]     = "0 0 0 0";
	sizes[0]      = 0.35;
	sizes[1]      = 0.9;

	useInvAlpha = true;
};

datablock ParticleEmitterData(flameExplosionEmitter)
{
   ejectionPeriodMS = 25;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.5;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "flameExplosionParticle";
};

datablock ExplosionData(flameExplosion)
{
   lifeTimeMS = 400;

   emitter[0] = flameExplosionEmitter;
   emitter[1] = flameExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10 10 10";
   camShakeAmp = "1 1 1";
   camShakeDuration = 0.5;
   camShakeRadius = 10;

   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "1 0.6 0";
   lightEndColor = "1 0.5 0";
};

//projectile
datablock ProjectileData(flameProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 3.0;
   particleEmitter     = flameTrailEmitter;

   muzzleVelocity      = 30;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 500;
   fadeDelay           = 450;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.50;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.2 0 0";
};


//////////
// item //
//////////
datablock ItemData(flame)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/flamer/flamer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a flame';
	invName = 'Flamethrower';
	image = flameImage;
};

//function flame::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}
////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(flameImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/flamer/flamer.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = flame;
   ammo = " ";
   projectile = flameProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.0;
	stateTransitionOnTimeout[0]       = "Ready";
	//stateSound[0]					= flameActivateSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;

	stateName[1]                   = "Ready";
	stateTransitionOnTriggerDown[1]= "Fire";
	stateAllowImageChange[1]       = true;
	stateEmitter[1]                = flameAmbientEmitter;
	stateEmitterTime[1]            = 1000;
	stateEmitterNode[1]            = "muzzlePoint";	

	stateName[2]                   = "Fire";
	stateTransitionOnTimeout[2]    = "Fire";
	stateTransitionOnTriggerUp[2]  = "Ready";
	stateTimeoutValue[2]           = 0.04;
	stateFire[2]                   = true;
	stateAllowImageChange[2]       = false;
	stateScript[2]                 = "onFire";
	stateWaitForTimeout[2]         = true;
	stateEmitter[2]                = flameFireEmitter;
	stateEmitterTime[2]            = 0.07;
	stateEmitterNode[2]            = "muzzlePoint";
	stateSound[2]		            = flameFireSound;
};


function flameProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{

   %player = %obj.client.player; 
   if(!%player) 
      return; 
   if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player") 
      return; 

   %colData = %col.getDataBlock(); 
   %colDataClass = %colData.classname; 

    radiusDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,"riflebullet",0);
       %colData = %col.getDataBlock(); 
       %colDataClass = %colData.classname;

//   if(%colDataClass $= "brick") 
//   { 
//         killBrick(%col); 
//   } 

if (%col.getClassName() $= "Player") 
      %col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 

}  