//missileLauncher.cs

datablock AudioProfile(missileLauncherExplosionSound)
{
   filename    = "~/data/sound/explo.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(missileLauncherFireSound)
{
   filename    = "~/data/sound/panz.wav";
   description = AudioClose3d;
   preload = true;
};

//missileLauncher trail
datablock ParticleData(missileLauncherTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 805;
	textureName          = "~/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.0 0.4";
	colors[1]     = "1.0 0.2 0.0 0.5";
	colors[2]     = "0.20 0.20 0.20 0.3";
	colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 0.25;
	sizes[1]      = 0.85;
	sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

 	times[0] = 0.0;
 	times[1] = 0.05;
 	times[2] = 0.3;
 	times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(missileLauncherTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;

   particles = missileLauncherTrailParticle;
};


//effects
datablock ParticleData(missileLauncherExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "~/data/shapes/weapons/flamer/flame1.png";
	//animTexName		= "~/data/shapes/weapons/missileLauncher/weapons/missileLauncher/cloud";

	// Interpolation variables
	colors[0]	= "0.3 0.3 0.2 0.9";
	colors[1]	= "0.2 0.2 0.2 0.0";
	sizes[0]	= 16.0;
	sizes[1]	= 28.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(missileLauncherExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "missileLauncherExplosionParticle";
};

datablock ParticleData(missileLauncherExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "~/data/shapes/weapons/flamer/blacksmoke.png";
	//animTexName		= "~/data/shapes/weapons/missileLauncher/weapons/missileLauncher/cloud";

	// Interpolation variables
	colors[0]	= "0.0 0.0 0.0 1.0";
	colors[1]	= "0.0 0.0 0.0 0.0";
	sizes[0]	= 8.5;
	sizes[1]	= 14.5;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(missileLauncherExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 14;
   ejectionVelocity = 15;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "missileLauncherExplosionParticle2";
};

datablock ExplosionData(missileLauncherExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 700;

   soundProfile = missileLauncherExplosionSound;

   emitter[0] = missileLauncherExplosionEmitter;
   emitter[1] = missileLauncherExplosionEmitter2;
   particleDensity = 30;
   particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(missileLauncherProjectile)
{
   projectileShapeName = "~/data/shapes/weapons/missileLauncher/projectile.dts";
   directDamage        = 100;
   radiusDamage        = 70;
   damageRadius        = 15;
   explosion           = missileLauncherExplosion;
   particleEmitter     = missileLauncherTrailEmitter;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 20000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.25;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(missileLauncher)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/missileLauncher/missileLauncher.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a missileLauncher';
	invName = 'missile Launcher';
	image = missileLauncherImage;
};

//function missileLauncher::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(missileLauncherImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/missileLauncher/missileLauncher.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = missileLauncher;
   ammo = " ";
   projectile = missileLauncherProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 1;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= missileLauncherFireSound;
};

function missileLauncherImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, missileLauncherReady);
}

function missileLauncherImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function missileLauncherImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, missileLauncherThrow);
	Parent::onFire(%this, %obj, %slot);
}

function missilelauncherProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
   %player = %obj.client.player;
   if(!%player)
      return;
if (%col.getClassName() $= "Baseplate") 
	return;

    radiusDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,"riflebullet",0);
       %colData = %col.getDataBlock(); 
       %colDataClass = %colData.classname;

//   if(%colDataClass $= "brick") 
//   { 
//         killBrick(%col); 
//   } 

if (%col.getClassName() $= "Player") 
      %col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 

}
