//paintBall.cs
//Paintball gun shoots projectiles that change the color of bricks, destroy bricks, and/or do damage to players
//Created by WGJHSTT24/7 with the help of [zero] and the blockland community on 2/23/05

//////////////////
//AUDIO SETTINGS//
/////////////////

datablock AudioProfile(sprayFireSound)
{
   filename    = "~/data/sound/footfall.wav";
   description = AudioClosestLooping3d;
   preload = true;
};

datablock AudioProfile(sprayHitSound)
{
   filename    = "~/data/sound/arrowHit.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(sprayActivateSound)
{
   filename    = "~/data/sound/sprayActivate.wav";
   description = AudioClosest3d;
   preload = true;
};


/////////////
//PARTICLES//
/////////////
datablock ParticleData(bluepaintBallTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "~/data/particles/paintball";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "0.000 0.317 0.745 0.500";
	colors[1]	= "0.000 0.317 0.745 0.000";
	sizes[0]	= 0.2;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleData(redpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.867 0.000 0.000 0.500";
	colors[1]	= "0.867 0.000 0.000 0.000";
};
datablock ParticleData(greenpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.000 0.471 0.196 0.500";
	colors[1]	= "0.000 0.471 0.196 0.000";
};
datablock ParticleData(yellowpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.973 0.800 0.000 0.500";
	colors[1]	= "0.973 0.800 0.000 0.000";
};
datablock ParticleData(graypaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.647 0.647 0.647 0.500";
	colors[1]	= "0.647 0.647 0.647 0.000";
};
datablock ParticleData(grayDarkpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.471 0.471 0.471 0.500";
	colors[1]	= "0.471 0.471 0.471 0.500";
};
datablock ParticleData(whitepaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.996 0.996 0.910 0.500";
	colors[1]	= "0.996 0.996 0.910 0.000";
};
datablock ParticleData(blackpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.200 0.200 0.200 0.500";
	colors[1]	= "0.200 0.200 0.200 0.000";
};
datablock ParticleData(brownpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.400 0.200 0.000 0.500";
	colors[1]	= "0.400 0.200 0.000 0.000";
};
datablock ParticleData(lightBluepaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.000 0.745 1.000 0.500";
	colors[1]	= "0.000 0.745 1.000 0.000";
};
datablock ParticleData(pinkpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "1.000 0.508 1.000 0.500";
	colors[1]	= "1.000 0.508 1.000 0.000";
};
datablock ParticleData(purplepaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.758 0.000 1.000 0.500";
	colors[1]	= "0.758 0.000 1.000 0.000";
};
datablock ParticleData(whitepersonpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.914 0.852 0.742 0.500";
	colors[1]	= "0.914 0.852 0.742 0.000";
};
datablock ParticleData(orangepaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "1.000 0.520 0.000 0.500";
	colors[1]	= "1.000 0.520 0.000 0.000";
};
datablock ParticleData(blackGpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.200 0.200 0.200 0.500";
	colors[1]	= "0.200 0.200 0.200 0.000";
};
datablock ParticleData(blueGpaintBallTrailParticle : bluepaintBallTrailParticle)
{
	colors[0]	= "0.000 0.317 0.745 0.500";
	colors[1]	= "0.000 0.317 0.745 0.000";
};

datablock ParticleData(bluepaintBallExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "~/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;
};

datablock ParticleData(redpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.867 0.000 0.000 0.500";
	colors[1]	= "0.867 0.000 0.000 0.000";
};
datablock ParticleData(greenpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.000 0.471 0.196 0.500";
	colors[1]	= "0.000 0.471 0.196 0.000";
};
datablock ParticleData(yellowpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.973 0.800 0.000 0.500";
	colors[1]	= "0.973 0.800 0.000 0.000";
};
datablock ParticleData(graypaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.647 0.647 0.647 0.500";
	colors[1]	= "0.647 0.647 0.647 0.000";
};
datablock ParticleData(grayDarkpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.471 0.471 0.471 0.500";
	colors[1]	= "0.471 0.471 0.471 0.500";
};
datablock ParticleData(whitepaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.996 0.996 0.910 0.500";
	colors[1]	= "0.996 0.996 0.910 0.000";
};
datablock ParticleData(blackpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.200 0.200 0.200 0.500";
	colors[1]	= "0.200 0.200 0.200 0.000";
};
datablock ParticleData(brownpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.400 0.200 0.000 0.500";
	colors[1]	= "0.400 0.200 0.000 0.000";
};
datablock ParticleData(lightBluepaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.000 0.745 1.000 0.500";
	colors[1]	= "0.000 0.745 1.000 0.000";
};
datablock ParticleData(pinkpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "1.000 0.508 1.000 0.500";
	colors[1]	= "1.000 0.508 1.000 0.000";
};
datablock ParticleData(purplepaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.758 0.000 1.000 0.500";
	colors[1]	= "0.758 0.000 1.000 0.000";
};
datablock ParticleData(whitepersonpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.914 0.852 0.742 0.500";
	colors[1]	= "0.914 0.852 0.742 0.000";
};
datablock ParticleData(orangepaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "1.000 0.520 0.000 0.500";
	colors[1]	= "1.000 0.520 0.000 0.000";
};
datablock ParticleData(blackGpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.200 0.200 0.200 0.500";
	colors[1]	= "0.200 0.200 0.200 0.000";
};
datablock ParticleData(blueGpaintBallExplosionParticle : bluepaintBallExplosionParticle)
{
	colors[0]	= "0.000 0.317 0.745 0.500";
	colors[1]	= "0.000 0.317 0.745 0.000";
};

////////////
//EMITTERS//
////////////
datablock ParticleEmitterData(bluepaintBallTrailEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;
	particles = bluepaintBallTrailParticle;
};

datablock ParticleEmitterData(redpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = redpaintBallTrailParticle;
};
datablock ParticleEmitterData(greenpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = greenpaintBallTrailParticle;
};
datablock ParticleEmitterData(yellowpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = yellowpaintBallTrailParticle;
};
datablock ParticleEmitterData(graypaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = graypaintBallTrailParticle;
};	
datablock ParticleEmitterData(grayDarkpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = grayDarkpaintBallTrailParticle;
};
datablock ParticleEmitterData(whitepaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = whitepaintBallTrailParticle;
};
datablock ParticleEmitterData(blackpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = blackpaintBallTrailParticle;
};
datablock ParticleEmitterData(brownpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = brownpaintBallTrailParticle;
};
datablock ParticleEmitterData(lightBluepaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = lightBluepaintBallTrailParticle;
};
datablock ParticleEmitterData(pinkpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = pinkpaintBallTrailParticle;
};
datablock ParticleEmitterData(purplepaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = purplepaintBallTrailParticle;
};
datablock ParticleEmitterData(whitepersonpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = whitepersonpaintBallTrailParticle;
};
datablock ParticleEmitterData(orangepaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = orangepaintBallTrailParticle;
};
datablock ParticleEmitterData(blackGpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = blackGpaintBallTrailParticle;
};
datablock ParticleEmitterData(blueGpaintBallTrailEmitter : bluepaintBallTrailEmitter){
	particles = blueGpaintBallTrailParticle;
};

datablock ParticleEmitterData(bluepaintBallExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "bluepaintBallExplosionParticle";
};

datablock ParticleEmitterData(redpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = redpaintBallExplosionParticle;
};
datablock ParticleEmitterData(greenpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = greenpaintBallExplosionParticle;
};
datablock ParticleEmitterData(yellowpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = yellowpaintBallExplosionParticle;
};
datablock ParticleEmitterData(graypaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = graypaintBallExplosionParticle;
};	
datablock ParticleEmitterData(grayDarkpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = grayDarkpaintBallExplosionParticle;
};
datablock ParticleEmitterData(whitepaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = whitepaintBallExplosionParticle;
};
datablock ParticleEmitterData(blackpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = blackpaintBallExplosionParticle;
};
datablock ParticleEmitterData(brownpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = brownpaintBallExplosionParticle;
};
datablock ParticleEmitterData(lightBluepaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = lightBluepaintBallExplosionParticle;
};
datablock ParticleEmitterData(pinkpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = pinkpaintBallExplosionParticle;
};
datablock ParticleEmitterData(purplepaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = purplepaintBallExplosionParticle;
};
datablock ParticleEmitterData(whitepersonpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = whitepersonpaintBallExplosionParticle;
};
datablock ParticleEmitterData(orangepaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = orangepaintBallExplosionParticle;
};
datablock ParticleEmitterData(blackGpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = blackGpaintBallExplosionParticle;
};
datablock ParticleEmitterData(blueGpaintBallExplosionEmitter : bluepaintBallExplosionEmitter){
	particles = blueGpaintBallExplosionParticle;
};

//////////////
//EXPLOSIONS//
//////////////
datablock ExplosionData(bluepaintBallExplosion)
{

//explosionShape = "";
	soundProfile = sprayHitSound;

   lifeTimeMS = 700;

   particleEmitter = bluepaintBallExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0 0 1";
   lightEndColor = "0 0 0";

};


//ok apparently, inheritance doesnt work for explosionDatas.

datablock ExplosionData(redpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = redpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 0 0";
   lightEndColor = "0 0 0";

};
datablock ExplosionData(greenpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = greenpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0 1 1";
   lightEndColor = "0 0 0";

};
datablock ExplosionData(yellowpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = yellowpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0 1 0";
   lightEndColor = "0 0 0";

};
datablock ExplosionData(graypaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = graypaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 1";
   lightEndColor = "0 0 0";

};	
datablock ExplosionData(grayDarkpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = grayDarkpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 1";
   lightEndColor = "0 0 0";

};
datablock ExplosionData(whitepaintBallExplosion ){
	lifeTimeMS = 150;
	particleEmitter = whitepaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 1";
   lightEndColor = "0 0 0";

};
datablock ExplosionData(blackpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = blackpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 1";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(brownpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = brownpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 0.5 0.5";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(lightBluepaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = lightBluepaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0 1 1";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(pinkpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = pinkpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "2 1 1";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(purplepaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = purplepaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 0 1";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(whitepersonpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = whitepersonpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 1";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(orangepaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = orangepaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 0";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(blackGpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = blackGpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "1 1 1";
   lightEndColor = "0 0 0";
};
datablock ExplosionData(blueGpaintBallExplosion){
	lifeTimeMS = 150;
	particleEmitter = blueGpaintBallExplosionEmitter;
	particleDensity = 10;
	particleRadius = 0.2;
	faceViewer     = true;
	explosionScale = "1 1 1";
	shakeCamera = false;
	soundProfile = sprayHitSound;
   lightStartRadius = 1;
   lightEndRadius = 0;
   lightStartColor = "0 0 1";
   lightEndColor = "0 0 0";
};

///////////////
//PROJECTILES//
///////////////
datablock ProjectileData(bluepaintBallProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0.5;
   explosion           = bluepaintBallExplosion;
   particleEmitter     = bluepaintBallTrailEmitter;

   muzzleVelocity      = 100; //20 - default
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 20000; //250 - default
   fadeDelay           = 7500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.15;

   hasLight    = false;
   lightRadius = 1;
   lightColor  = "0 0 0";
};

datablock ProjectileData(redpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= redpaintBallExplosion;
	particleEmitter = redpaintBallTrailEmitter;
};
datablock ProjectileData(greenpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;	
	explosion		= greenpaintBallExplosion;
	particleEmitter = greenpaintBallTrailEmitter;
};
datablock ProjectileData(yellowpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;	
	explosion		= yellowpaintBallExplosion;
	particleEmitter = yellowpaintBallTrailEmitter;
};
datablock ProjectileData(graypaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= graypaintBallExplosion;
	particleEmitter = graypaintBallTrailEmitter;
};	
datablock ProjectileData(grayDarkpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= grayDarkpaintBallExplosion;
	particleEmitter = grayDarkpaintBallTrailEmitter;
};
datablock ProjectileData(whitepaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= whitepaintBallExplosion;
	particleEmitter = whitepaintBallTrailEmitter;
};
datablock ProjectileData(blackpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= blackpaintBallExplosion;
	particleEmitter = blackpaintBallTrailEmitter;
};
datablock ProjectileData(brownpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= brownpaintBallExplosion;
	particleEmitter = brownpaintBallTrailEmitter;
};
datablock ProjectileData(lightBluepaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= lightBluepaintBallExplosion;
	particleEmitter = lightBluepaintBallTrailEmitter;
};
datablock ProjectileData(pinkpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= pinkpaintBallExplosion;
	particleEmitter = pinkpaintBallTrailEmitter;
};
datablock ProjectileData(purplepaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= purplepaintBallExplosion;
	particleEmitter = purplepaintBallTrailEmitter;
};
datablock ProjectileData(whitepersonpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= whitepersonpaintBallExplosion;
	particleEmitter = whitepersonpaintBallTrailEmitter;
};
datablock ProjectileData(orangepaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= orangepaintBallExplosion;
	particleEmitter = orangepaintBallTrailEmitter;
};
datablock ProjectileData(blackGpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= blackGpaintBallExplosion;
	particleEmitter = blackGpaintBallTrailEmitter;
};
datablock ProjectileData(blueGpaintBallProjectile : bluepaintBallProjectile){
	   directDamage        = 0;
   	   radiusDamage        = 0;
   	   damageRadius        = 0.5;
	explosion		= blueGpaintBallExplosion;
	particleEmitter = blueGpaintBallTrailEmitter;
};

/////////
//ITEMS//
/////////
datablock ItemData(paintBall)
{
	category = "Weapon";  // Mission editor category
	className = "paintBall";   // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/paintball/paintballgun.dts";
	skinName = 'orange';
	rotate = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a paintball gun.';
	invName = 'Paintball Gun';
	image = orangepaintBallImage;
};



//////////
//IMAGES//
//////////
datablock ShapeBaseImageData(bluepaintBallImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/paintball/paintballgun.dts";
   skinName = 'blue';
   emap = false;

   mountPoint = 0;
   offset = "0 0 0";

   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = paintBall;
   ammo = " ";
   projectile = bluepaintBallProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state. sprayActivateSound, sprayFireSound

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= sprayActivateSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = true;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= sprayFireSound;
	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = true;
	stateTimeoutValue[3]            = 0.5;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = true;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";

};

datablock ShapeBaseImageData(redpaintBallImage : bluepaintBallImage){
	skinName = 'red';
	projectile = redpaintBallProjectile;
};
datablock ShapeBaseImageData(greenpaintBallImage : bluepaintBallImage){
	skinName = 'green';
	projectile = greenpaintBallProjectile;
};
datablock ShapeBaseImageData(yellowpaintBallImage : bluepaintBallImage){
	skinName = 'yellow';
	projectile = yellowpaintBallProjectile;
};
datablock ShapeBaseImageData(graypaintBallImage : bluepaintBallImage){
	skinName = 'gray';
	projectile = graypaintBallProjectile;
};
datablock ShapeBaseImageData(grayDarkpaintBallImage : bluepaintBallImage){
	skinName = 'grayDark';
	projectile = grayDarkpaintBallProjectile;
};
datablock ShapeBaseImageData(whitepaintBallImage : bluepaintBallImage){
	skinName = 'white';
	projectile = whitepaintBallProjectile;
};
datablock ShapeBaseImageData(blackpaintBallImage : bluepaintBallImage){
	skinName = 'black';
	projectile = blackpaintBallProjectile;
};
datablock ShapeBaseImageData(brownpaintBallImage : bluepaintBallImage){
	skinName = 'brown';
	projectile = brownpaintBallProjectile;
};
datablock ShapeBaseImageData(lightBluepaintBallImage : bluepaintBallImage){
	skinName = 'lightBlue';
	projectile = lightBluepaintBallProjectile;
};
datablock ShapeBaseImageData(pinkpaintBallImage : bluepaintBallImage){
	skinName = 'pink';
	projectile = pinkpaintBallProjectile;
};
datablock ShapeBaseImageData(purplepaintBallImage : bluepaintBallImage){
	skinName = 'purple';
	projectile = purplepaintBallProjectile;
};
datablock ShapeBaseImageData(whitepersonpaintBallImage : bluepaintBallImage){
	skinName = 'whiteperson';
	projectile = whitepersonpaintBallProjectile;
};
datablock ShapeBaseImageData(orangepaintBallImage : bluepaintBallImage){
	skinName = 'orange';
	projectile = orangepaintBallProjectile;
};
datablock ShapeBaseImageData(blackGpaintBallImage : bluepaintBallImage){
	skinName = 'blackG';
	projectile = blackGpaintBallProjectile;
};
datablock ShapeBaseImageData(blueGpaintBallImage : bluepaintBallImage){
	skinName = 'blueG';
	projectile = blueGpaintBallProjectile;
};

///////////
//METHODS//
///////////

//using the paintBall can item
function paintBall::onUse(%this,%player, %invPosition)
{
	%client = %player.client;
	if(%client){
		%color = %client.color;
	}
	%mountedImage = %player.getMountedImage($RightHandSlot);

	//if a spray can is already mounted
	if(%mountedImage.item $= "paintBall" && (%player.currWeaponSlot == %invPosition)) {
		//mount the next color
		if(%mountedImage == nameToID("redpaintBallImage")){
			%image = yellowpaintBallImage;
			%client.color = "yellow";
		}			
		else if(%mountedImage == nameToID("yellowpaintBallImage")){
			%image = greenpaintBallImage;
			%client.color = "green";
		}
		else if(%mountedImage == nameToID("greenpaintBallImage")){
			%image = bluepaintBallImage;
			%client.color = "blue";
		}
		else if(%mountedImage == nameToID("bluepaintBallImage")){
			%image = whitepaintBallImage;
			%client.color = "white";
		}
		else if(%mountedImage == nameToID("whitepaintBallImage")){
			%image = graypaintBallImage;
			%client.color = "gray";
		}
		else if(%mountedImage == nameToID("graypaintBallImage")){
			%image = grayDarkpaintBallImage;
			%client.color = "grayDark";
		}
		else if(%mountedImage == nameToID("grayDarkpaintBallImage")){
			%image = blackpaintBallImage;
			%client.color = "black";
		}
		else if(%mountedImage == nameToID("blackpaintBallImage")){
			%image = brownpaintBallImage;
			%client.color = "brown";
		}
		else if(%mountedImage == nameToID("brownpaintBallImage")){
			%image = lightBluepaintBallImage;
			%client.color = "lightBlue";
		}
		else if(%mountedImage == nameToID("lightBluepaintBallImage")){
			%image = pinkpaintBallImage;
			%client.color = "pink";
		}
		else if(%mountedImage == nameToID("pinkpaintBallImage")){
			%image = purplepaintBallImage;
			%client.color = "purple";
		}
		else if(%mountedImage == nameToID("purplepaintBallImage")){
			%image = whitepersonpaintBallImage;
			%client.color = "whiteperson";
		}
		else if(%mountedImage == nameToID("whitepersonpaintBallImage")){
			%image = orangepaintBallImage;
			%client.color = "orange";
		}
		else if(%mountedImage == nameToID("orangepaintBallImage")){
			%image = blackGpaintBallImage;
			%client.color = "blackG";
		}
		else if(%mountedImage == nameToID("blackGpaintBallImage")){
			%image = blueGpaintBallImage;
			%client.color = "blueG";
		}
		else if(%mountedImage == nameToID("blueGpaintBallImage")){
			%image = redpaintBallImage;
			%client.color = "red";
		}
		%player.mountImage(%image, $RightHandSlot, 1, %image.skinName);
	}
	//else,
	else {
		//if the client has a color, use that
		if(%color !$= ""){
			%image = nameToID(%color @ "paintBallImage");
			%player.mountImage(%image, $RightHandSlot, 1, %image.skinName);
		}
		else{
			//else, mount the default
			%image = redpaintBallImage;
			%player.mountImage(%image, $RightHandSlot, 1, %image.skinName);
		}
		//hilight inv slot
		messageClient(%client, 'MsgHilightInv', '', %InvPosition);
		%player.currWeaponSlot = %invPosition;
	}
}

//////////////
//COLLISIONS//
//////////////
function killBrick(%brick) 
{ 
    
   //tag this brick as dead 
   %brick.dead = true; 

   //explode this brick 
   %brick.schedule(10, explode); 
} 


// JBM add: Common collision function
// GlenStew added GroupTrust
function commonCollision(%col, %obj, %color)
{
	%isTrusted = 0;
	//echo("checking trustlist");
	for(%i = 0; %i <= $Trust::numTrusts; %i++)
	{
		if(%col.owner $= $Trust::ip[%i])
		{
			%isTrusted = 1;
		}
	}
	%isGroupBrick = 0;
	for(%i = 0; %i <= $Group::numGroup; %i++)
	{
		if(%col.owner $= $Group::ip[%i])
		{
			%isGroupBrick = 1;
		}
	}
	//%col.getDataBlock().className $= "Baseplate"
	//qMessage(%col.getDataBlock().className);
	if(%obj.client.grouped == 1)
	{
		if(%col.getClassName() $= "StaticShape" || %col.getClassName() $= "Player")
			%col.setSkinName(%color);
	}

	else if((%isGroupBrick ==0) && (%obj.client.grouped == 0))
	{
		if( %col.owner $= getRawIP(%obj.client) || (%isTrusted == 0) || !(%col.getDataBlock().className $= "Brick"))
		{
			if(%col.getClassName() $= "StaticShape" || %col.getClassName() $= "Player")
			%col.setSkinName(%color);
		}
	}
}

function redpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'red'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function bluepaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'blue'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function yellowpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'yellow'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function greenpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'green'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

   if (%col.getClassName() $= "Player")
      %col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
}
function graypaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'gray'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function grayDarkpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'grayDark'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function whitepaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'white'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function blackpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'black'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function brownpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'brown'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function lightBluepaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'lightBlue'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function pinkpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'pink'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function purplepaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'purple'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function whitepersonpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'whiteperson'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function orangepaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'orange'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function blackGpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'blackG'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}
function blueGpaintBallProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	commonCollision(%col, %obj, 'blueG'); 
	//paintBall
	if(!%player)
	{
      	return;
	}
   	if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player")
	{
      	return;
	}
   	%colData = %col.getDataBlock();
   	%colDataClass = %colData.classname;

 	//  if(%colDataClass $= "brick")
 	//  {
 	//        killBrick(%col);
 	//  }

   	if (%col.getClassName() $= "Player")
	{
      	%col.damage(%obj,%pos,%this.directDamage,"RifleBullet"); 
	}

}

////////////////////////
//paintBall FUNCTION!//
//////////////////

//%player = %obj.client.player;

	//if theres no player, (or client) bail out now
//	if(!%player)
//		return;


//if (%col.getClassName() !$= "StaticShape" & %col.getClassName() !$= "Player" & %col.getclassname() !$= "WheeledVehicle")
//		return;

//	%colData = %col.getDataBlock();
//	%colDataClass = %colData.classname;

//if(%colDataClass $= "brick")
//	{
		//brick must be exposed on either the top of the bottom
		//this assumes that the brick is not floating

//			killBrick(%col);

//	}

   // Apply damage to the object all shape base objects
//  if (%col.getType() & $TypeMasks::ShapeBaseObjectType)
//      %col.damage(%obj,%pos,%this.directDamage,"RifleBullet");

   // Radius damage is a support scripts defined in radiusDamage.cs
//if (%col.getClassName() $= "Player" )
//  %col.damage(%obj,%pos,%this.damageRadius,%this.radiusDamage,"RifleBullet",0);

//if (%col.getclassname() $= "WheeledVehicle")
//  radiusDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,"arrowProjectile",0);